﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.DragDrop;

namespace DragDropManagerSL
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            DragDropManager.AddDragInitializeHandler(this.ListBox1, OnDragInitialize);
            DragDropManager.AddDragOverHandler(this.ListBox2, OnDragOver);
            DragDropManager.AddDropHandler(this.ListBox2, OnDrop);
            DragDropManager.AddGiveFeedbackHandler(this.ListBox1, OnGiveFeedback);
        }

        private void OnGiveFeedback(object sender, GiveFeedbackEventArgs e)
        {
            if (e.Effects == DragDropEffects.None)
            {
                e.SetCursor(Cursors.None);
            }
        }

        private void OnDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
        {
            var data = DragDropPayloadManager.GetDataFromObject(e.Data, "DragData");
            ((IList)(sender as RadListBox).ItemsSource).Add(data);
            e.Handled = true;
        }

        private void OnDragOver(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
        {
            var data = DragDropPayloadManager.GetDataFromObject(e.Data, "DragData");
            if (((IList)(sender as RadListBox).ItemsSource).Contains(data))
            {
                e.Effects = DragDropEffects.None;
            }
            else
            {
                e.Effects = DragDropEffects.All;
            }

            e.Handled = true;
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs e)
        {
            e.AllowedEffects = DragDropEffects.All;
            var payload = DragDropPayloadManager.GeneratePayload(null);
            var data = ((FrameworkElement)e.OriginalSource).DataContext;
            payload.SetData("DragData", data);
            e.Data = payload;
            e.Handled = true;
        }
    }
}
